local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary

local GetPowerRegen = GetPowerRegen
local math = math
local select = select

a.Rotations = {}
c.RegisterForEvents(a)
a.SetSpamFunction(function()
	a.InExecute = s.HealthPercent() < 20
	a.Rage = c.GetPower(select(2, GetPowerRegen()))
	a.Enraged = c.HasBuff("Enrage", true)
	local info = c.GetQueuedInfo()
--if info then c.Debug("Queued", info.Name) end
	if c.InfoMatches(info, "Berserker Rage") then
		a.Rage = a.Rage + 10
		a.Enraged = true
	elseif c.InfoMatches(
		info, "Battle Shout", "Commanding Shout", "Charge") then
		
		a.Rage = a.Rage + 20
	elseif c.InfoMatches(info, "Shield Slam") then
		if s.Buff("player", c.GetID("Sword and Board")) then
			a.Rage = a.Rage + 25
		else
			a.Rage = a.Rage + 20
		end
	elseif c.InfoMatches(info, "Revenge") then
		a.Rage = a.Rage + 15
	end
	a.Rage = math.min(s.MaxPower("player"), a.Rage)
	a.EmptyRage = s.MaxPower("player") - a.Rage
	c.Flash(a)
end)

-------------------------------------------------------------------------- Arms
a.Rotations.Arms = {
	Spec = 1,
	OffSwitch = "arms_off",
	
	FlashInCombat = function()
		c.FlashAll(
			"Berserker Rage",
			"Heroic Leap",
			"Pummel",
			"Disrupting Shout")
		if a.InExecute then
			c.PriorityFlash(
				"Mortal Strike",
				"Colossus Smash",
				"Execute",
				"Storm Bolt",
				"Overpower",
				"Shockwave",
				"Dragon Roar",
				"Heroic Throw",
				"Shout for Rage")
		else
			c.FlashAll("Deadly Calm for Arms", "Heroic Strike for Arms")
			c.PriorityFlash(
				"Mortal Strike",
				"Colossus Smash",
				"Storm Bolt",
				"Overpower",
				"Shockwave",
				"Dragon Roar",
				"Slam with Colossus Smash or High Rage",
				"Heroic Throw",
				"Shout for Rage unless Colossus Smash",
				"Bladestorm for Arms",
				"Slam",
				"Impending Victory",
				"Shout for Rage")
		end
	end,
	
	FlashAlways = function()
		c.FlashAll("Dps Stance")
	end,
}

-------------------------------------------------------------------------- Fury
a.Rotations.Fury = {
	Spec = 2,
	OffSwitch = "fury_off",
	
	FlashInCombat = function()
		c.FlashAll(
			"Recklessness",
			"Berserker Rage",
			"Heroic Leap",
			"Deadly Calm for Fury", 
			"Heroic Strike for Fury",
			"Pummel",
			"Disrupting Shout")
			
		local cd = c.GetCooldown("Bloodthirst")
		if cd > 0 and cd <= 1 then
			if not a.InExecute then
				c.PriorityFlash("Wild Strike under Bloodsurge")
			end
--c.Debug("Wait", a.Rage, not not a.Enraged)
			return
		end
		
		if a.InExecute then
			c.PriorityFlash(
				"Bloodthirst",
				"Colossus Smash",
				"Execute",
				"Storm Bolt",
				"Shockwave",
				"Dragon Roar",
				"Heroic Throw",
				"Shout")
		else
c.Debug("Flash", a.Rage, not not a.Enraged,
			c.PriorityFlash(
				"Bloodthirst",
				"Colossus Smash",
				"Storm Bolt",
				"Raging Blow",
				"Wild Strike under Bloodsurge",
				"Shockwave",
				"Dragon Roar",
				"Heroic Throw",
				"Shout for Rage unless Colossus Smash",
				"Bladestorm for Fury",
				"Wild Strike under Colossus Smash",
				"Impending Victory",
				"Wild Strike at 60 unless Colossus Smash",
				"Shout for Rage")
)
		end
	end,
	
	FlashAlways = function()
		c.FlashAll("Dps Stance")
	end,
}

-------------------------------------------------------------------- Protection
local uncontrolledMitigationCooldowns = {
	"Second Wind",
	"Spell Reflection",
	"Rallying Cry",
}

a.Rotations.Protection = {
	Spec = 3,
	OffSwitch = "prot_off",
	
	FlashInCombat = function()
		c.FlashMitigationBuffs(
			1,
			uncontrolledMitigationCooldowns,
			"No Mitigation if Victory Available",
			"Demoralizing Shout",
			"Enraged Regeneration",
			"Shield Wall under 3 min",
			"Last Stand",
			"Shield Wall 3+ min")
		c.FlashAll(
			"Shield Block",
			"Shield Barrier",
			"Berserker Rage for Prot",
			"Heroic Strike for free",
			"Taunt",
			"Pummel",
			"Disrupting Shout")
c.Debug("Flash", a.Rage,
		c.PriorityFlash(
--			"Shockwave for Stun",
--			"Dragon's Roar for Stun",
			"Thunder Clap for Debuff",
			"Impending Victory for Heals",
			"Victory Rush for Heals",
			"Shield Slam",
			"Revenge",
			"Shout for Rage",
			"Thunder Clap for Refresh",
			"Deadly Calm Glyphed",
			"Devestate")
)
	end,
	
	FlashAlways = function()
		c.FlashAll("Defensive Stance")
	end,
}
